[![Build Status](https://travis-ci.org/mikessh/vdjtools.svg?branch=master)](https://travis-ci.org/mikessh/vdjtools)
[![JitPack](https://jitpack.io/v/mikessh/vdjtools.svg)](https://jitpack.io/#mikessh/vdjtools)

## VDJtools

A comprehensive analysis framework for T-cell and B-cell repertoire sequencing data. Compiled binaries are available from [here](https://github.com/mikessh/vdjtools/releases/latest). You can download them and execute as

```bash
java -jar vdjtools.jar ...
```

Make sure that you've specified the full/correct path to jar file. In case of Java Heap Space exception, you can increase the JVM memory limit by adding ``-Xmx20G`` (for extra 20G) after the ``-jar`` argument.

The software is cross-platform and requires Java v1.8+ to run and R to perform plotting.

Easy installation on **MacOS/Linux** via [Homebrew](http://brew.sh/) or [Linuxbrew](http://linuxbrew.sh/):
```bash
brew tap homebrew/science
brew tap mikessh/repseq
brew install vdjtools
vdjtools CalcBasicStats ...
```
See [homebrew-repseq](https://github.com/mikessh/homebrew-repseq) for other RepSeq analysis software Homebrew installers.

List of features and detailed documentation can be found at [ReadTheDocs](http://vdjtools-doc.readthedocs.io).

Example datasets and shell scripts are provided in a separate [repository](https://github.com/mikessh/vdjtools-examples).

### Please cite VDJtools as:

Shugay M et al. VDJtools: Unifying Post-analysis of T Cell Receptor Repertoires. [PLoS Comp Biol 2015; 11(11):e1004503-e1004503](http://journals.plos.org/ploscompbiol/article?id=10.1371/journal.pcbi.1004503).

### Some recent publications where VDJtools was used:

- Feng Y et al. A mechanism for expansion of regulatory T-cell repertoire and its role in self-tolerance. [Nature 2015; doi:10.1038/nature16141](http://www.nature.com/nature/journal/vaop/ncurrent/full/nature16141.html)
- Britanova OV et al. Dynamics of Individual T Cell Repertoires: From Cord Blood to Centenarians. [J Immunol 2016; doi:10.4049/jimmunol.1600005](http://www.jimmunol.org/content/196/12/5005.short)
- Joachims ML et al. Single-cell analysis of glandular T cell receptors in Sjögren’s syndrome. [JCI Insight 2016; doi:10.1172/jci.insight.85609](https://insight.jci.org/articles/view/85609)
- Plitas G et al. Regulatory T cells exhibit distinct features in human breast cancer. [Immunity 2017; doi.org:10.1016/j.immuni.2016.10.032](http://www.sciencedirect.com/science/article/pii/S1074761316304435)
- Izraelson M et al. Comparative Analysis of Murine T Cell Receptor Repertoires. [Immunology 2017; doi.org:10.1111/imm.12857](http://onlinelibrary.wiley.com/doi/10.1111/imm.12857/full)
- Bolotin DA et al. Antigen receptor repertoire profiling from RNA-seq data. [Nat Biotech 2017; doi:10.1038/nbt.3979](https://www.nature.com/articles/nbt.3979)
- Meng W et al. An atlas of B-cell clonal distribution in the human body. [Nat Biotech 2017; doi:10.1038/nbt.3942](https://www.nature.com/articles/nbt.3942)

args<-commandArgs(TRUE)

file_in  <- args[1]
file_out <- args[2]

require(circlize); require(RColorBrewer)


# load data and preproc to fit formats

temp <- read.table(file_in, sep="\t", comment="")
n <- nrow(temp)
m <- ncol(temp)
rn = as.character(temp[2:n,1])
cn = apply(temp[1,2:m], 2 , as.character)
mat <- matrix(apply(temp[2:n, 2:m], 1:2, as.numeric), n - 1, m-1) * 100

n <- nrow(temp)
m <- ncol(temp)

# Here columns and rows correspond to V and J segments respectively
# Also replace possible duplicates (undef, '.', ...)

duplicates <- intersect(rn, cn)

rownames(mat) <- replace(rn, rn==duplicates, paste("V", duplicates, sep=""))
colnames(mat) <- replace(cn, cn==duplicates, paste("J", duplicates, sep=""))

# sort

col_sum = apply(mat, 2, sum)
row_sum = apply(mat, 1, sum)

mat <- mat[order(row_sum), order(col_sum)]

# equal number of characters for visualizaiton

rn <- rownames(mat)
cn <- colnames(mat)

maxrn <- max(nchar(rn))
maxcn <- max(nchar(cn))

for(i in seq_len(length(rn))) {
      rn[i] <- paste(rn[i], paste(rep(" ", maxrn - nchar(rn[i])), collapse = ''))
}

for(i in seq_len(length(cn))) {
      cn[i] <- paste(cn[i], paste(rep(" ", maxcn - nchar(cn[i])), collapse = ''))
}

rownames(mat) <- rn
colnames(mat) <- cn

# viz using circlize

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}

circos.par(gap.degree = c(rep(1, nrow(mat)-1), 10, rep(1, ncol(mat)-1), 15), start.degree = 5)

rcols <- rep(brewer.pal(12, "Paired"), nrow(mat)/12 + 1)[1:nrow(mat)]
ccols <- rep(brewer.pal(12, "Paired"), ncol(mat)/12 + 1)[1:ncol(mat)]

names(rcols) <- sort(rownames(mat))
names(ccols) <- sort(colnames(mat))

chordDiagram(mat, annotationTrack = "grid",
             grid.col = c(rcols, ccols),
             preAllocateTracks = list(track.height = 0.2), transparency = 0.5)

circos.trackPlotRegion(track.index = 1, bg.border = NA,
       panel.fun = function(x, y) {
                   sector.name = get.cell.meta.data("sector.index")
                   xlim = get.cell.meta.data("xlim")
                   ylim = get.cell.meta.data("ylim")
                   circos.text(mean(xlim), ylim[1], cex = 0.5, sector.name, facing = "clockwise", adj = c(0, 0.5))
                   }
       )

circos.clear()

dev.off()

require(ggplot2)

args <- commandArgs(T)

file_in  <- args[1] #"cdr3aa.profile.wt.txt"
file_out <- args[2] #"cdr3aa.profile.wt.pdf"
group_id <- as.integer(args[3]) #4
normalized <- as.logical(args[4]) #F

if (group_id < 1) {
   group_id = 1 # use sample id if not specified
}

df <- read.table(file_in, header=T, comment="", quote="", sep="\t", stringsAsFactors = F)

df$value <- as.numeric(df$value)
df$total <- as.numeric(df$total)

if (normalized) {
    df$value <- ifelse(df$total == 0, 0, df$value / df$total)
}

# collect required columns and select grouping column
groupName <- colnames(df)[group_id]

df <- data.frame(bin = factor(df$bin + 1), 
                 value = df$value,
                 property = df$property,
                 cdr3.segment = df$cdr3_segment,
                 group = factor(df[,group_id]))


# set order of segments
df$cdr3.segment <- factor(df$cdr3.segment, levels = c("CDR3-full",
  "V-germ",
  "VD-junc", "D-germ", "DJ-junc", "VJ-junc",
  "J-germ", "CDR3-center"))

get_facet_formula = function() {
  if (length(unique(df$property)) > 1) { 
    property ~ cdr3.segment
  } else {
    cdr3.segment ~ property
  }
}

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}

ggplot(df, aes(x=bin, y=value, color=group)) +
  geom_boxplot() + 
  facet_grid(get_facet_formula(), scales="free") +
  xlab("") + ylab("") +
  theme_bw() + scale_color_brewer(groupName, palette="Set2")

dev.off()


# you can further proceed with T-tests if you want..
#t.test(freq ~ genotype, subset(df, cdr3.segment == "VJ-junc" & property == "disorder"))

# data input

args <- commandArgs(TRUE)

require(gplots)

label    <- args[1] #"time since HSCT, months"
points   <- args[2] #"-48,-0.5,4,10,25,37,72"
file_in  <- args[3] #"tc_luc_table_collapsed.txt"
file_out <- args[4] #"out.pdf"

# load time points, create some auxillary variables
t <- apply(as.vector(read.table(text=points, sep=",")), 1, as.numeric)
n <- length(t)

# load data and remove collapse summary columns
df <- read.table(file_in, sep="\t", header = T, comment ="")
df <- df[1:(nrow(df)-2), ]

# convert abundance columns to numeric
tcols <- (ncol(df) - n + 1):ncol(df)
df[, tcols] <- apply(df[, tcols], 2, as.numeric)

# format (log-transform and scale)
y <- df[,tcols]
min <- min(y[y > 0])
max <- max(y)
x <- log10(as.matrix(y) + min / 10)
breaks = c(log10(min) - 1, seq(log10(min), log10(max), length.out = 20))
pal <- colorRampPalette(c("#2b8cbe", "#e0f3db", "#fdbb84"))

# plot

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}

heatmap.2(x, labRow = df$cdr3aa, labCol = t, Colv = FALSE, dendrogram = "row",
          scale = "none", cexRow = 0.2 + 0.5 / log10(nrow(x)), keysize = 1.0, symkey = FALSE,
          col = c("grey50", pal(length(breaks) - 2)), breaks = breaks,
          density.info="none", trace="none",
          srtCol=90, adjCol = c(1,0), xlab = label)

dev.off()

require(circlize); require(reshape2); require(RColorBrewer)

args<-commandArgs(TRUE)

file_in  <- args[1]
file_out <- args[2]

df <- read.table(file_in, header=T, comment="", quote="")
df[,] <- apply(df[,], 2, as.character)
df <- data.frame(sample1 = c(df$X1_sample_id, df$X2_sample_id),
                 sample2 = c(df$X2_sample_id, df$X1_sample_id),
                 count = as.numeric(c(df$count12, df$count21)),
                 frequency = as.numeric(c(df$freq12, df$freq21)),
                 diversity = as.numeric(c(df$div12, df$div21)))

# equate the number of characters for visualizaiton
adjust_labels <- function(mat) {
  rn <- rownames(mat)
  cn <- colnames(mat)

  maxrn <- max(nchar(rn))
  maxcn <- max(nchar(cn))

  for(i in seq_len(length(rn))) {
    rn[i] <- paste(rn[i], paste(rep(" ", maxrn - nchar(rn[i])), collapse = ''))
  }

  for(i in seq_len(length(cn))) {
    cn[i] <- paste(cn[i], paste(rep(" ", maxcn - nchar(cn[i])), collapse = ''))
  }

  rownames(mat) <- rn
  colnames(mat) <- cn
}

# plotting function
render_plot <- function(var) {
  mat <- acast(df, sample1 ~ sample2, value.var=var)
  
  diag(mat) <- 0
  #diag(mat) <- df[df$sample1==rownames(mat),"f1"] * (nrow(df) / 2 - 1) - # total possible overlap freq
  #  rowSums(mat, na.rm=T) # overlapped freq, note that row -> col is default direction for circlize
  adjust_labels(mat)

  # viz using circlize
  #circos.par(gap.degree = c(rep(3, nrow(mat)-1), 10, rep(3, ncol(mat)-1), 10), start.degree = 5)

  rcols <- rep(brewer.pal(12, "Paired"), nrow(mat)/12 + 1)[1:nrow(mat)]
  ccols <- rep(brewer.pal(12, "Paired"), ncol(mat)/12 + 1)[1:ncol(mat)]

  names(rcols) <- sort(rownames(mat))
  names(ccols) <- sort(colnames(mat))

  chordDiagram(mat, annotationTrack = "grid", grid.col = c(rcols, ccols),
               preAllocateTracks = list(track.height = 0.2), transparency = 0.5)

  circos.trackPlotRegion(track.index = 1, bg.border = NA,
                         panel.fun = function(x, y) {
                           sector.name = get.cell.meta.data("sector.index")
                           xlim = get.cell.meta.data("xlim")
                           ylim = get.cell.meta.data("ylim")
                           circos.text(mean(xlim), ylim[1], cex = 0.5, sector.name, facing = "clockwise", adj = c(0, 0.5))
                         }
  )
}

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}
vars <- c("count", "frequency", "diversity")
layout(t(matrix(c(0,0,0,1,2,3,0,0,0),3,3)))
for(var in vars) {
  par(mar = c(0.5, 0.5, 0.5, 0.5))
  render_plot(var)
  title(var)
  circos.clear()
}
dev.off()

require(ggplot2)

args<-commandArgs(TRUE)

file_in  <- args[1]
file_out <- args[2]

df <- read.table(file_in, sep="\t", comment="", header=T, stringsAsFactors=F, quote="")
df[,3:5]<-apply(df[,3:5],2,as.numeric)

df.l<-data.frame(factor=df$factor,type=df$type,obs=df$obs,p=df$p)
df.l<-df.l[!duplicated(df.l), ]

g<-ggplot(df,aes(x=perm))+geom_histogram(colour = "darkgrey", fill = "grey") +
geom_vline(aes(xintercept = obs), colour="red", size=1, linetype = "longdash") +
theme_bw() + xlab("") + scale_y_continuous(name="permutations") + facet_grid(type~factor)

df.l$perm<-rep(max(ggplot_build(g)$data[[1]]$count),nrow(df.l))

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}

g+geom_text(data = df.l, aes(x=obs, label=as.character(p), y=perm), hjust=-0.1)

dev.off()

# data input

args <- commandArgs(TRUE)

require(ggplot2); require(reshape); require(gridExtra); require(grid)

label    <- args[1] #"time since HSCT, months"
points   <- args[2] #"-48,-0.5,4,10,25,37,72"
file_in  <- args[3] #"luc_table_collapsed.txt"
file_out <- args[4] #"out.pdf"

#

# load time points, create some auxillary variables
x <- apply(as.vector(read.table(text=points, sep=",")), 1, as.numeric)
n <- length(x)

# load data
#df <- data.frame(read.delim(file_in))
df    <- read.table(file_in, comment="", sep = "\t", header = TRUE)
xcols <- (ncol(df) - n + 1):ncol(df)
fcols <- 1:(ncol(df) - n)
xlbls <- colnames(df)[xcols]

# convert abundance columns to numeric
df[, xcols] <- apply(df[, xcols], 2, as.numeric)

# set up Non-overlapping and Not-shown
df$peak[nrow(df)-1] <- -1
df$peak[nrow(df)] <- -2

# for label placement
cs <- cumsum(df[,xcols])
peak <- df$peak + 1
peak[peak < 1] <- NA
lbl.peak <- as.vector(df[!is.na(peak), "peak"])
lbl.txt <- as.vector(df[!is.na(peak), "cdr3aa"])
lbl.x <- as.vector(na.omit(x[peak]))
lbl.y <- sapply(as.vector(na.omit(cs[cbind(1:nrow(cs), peak)])), as.numeric)
lbl.max <- sapply(as.vector(na.omit(df[cbind(1:nrow(df), xcols[peak])])), as.numeric)
lbl.p <- as.numeric(as.vector(df[!is.na(peak), "sampling.p"]))+1e-20

lbl <- data.frame(txt = lbl.txt, x = lbl.x, y = lbl.y, max = lbl.max, p.adj = lbl.p)

# reshape data
df.m <- melt(df, id = fcols)

# replace sample ids (factor) by time (numeric)
ind <- match(df.m$variable, xlbls)
df.m$variable <- x[ind]

df.m$sign <- paste(df.m$cdr3nt, df.m$v, df.m$d, df.m$j, sep="_")

pal <- colorRampPalette(c("#2b8cbe", "#e0f3db", "#fdbb84"))

#draw

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}

# prepare plot
g<-ggplot() +
   geom_area(data = df.m,
             aes(variable, value, group = sign, fill = factor(peak)),
             colour = "gray25", position = 'stack', size = 0) +
   scale_fill_manual(
      name   = "Peak position",
      breaks = c(-2, -1, 0:(n-1)),
      labels = c("Non-overlapping", "Not-shown", x),
      values = c("grey50", "grey70", pal(n))
      ) +
   scale_x_continuous(expand = c(0,0), limit = c(min(x), max(x)), breaks = x) +
   scale_y_continuous(expand = c(0,0)) +
   theme_bw() +
   xlab(label) +
   ylab("abundance") +
   theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust = 0.5), panel.border = element_blank()) +
   geom_text(data = subset(lbl, peak == 1), aes(x, y, label = txt, size = max, alpha = -log10(p.adj)), color = "gray10", hjust = 0, vjust = 0.5) +
   geom_text(data = subset(lbl, peak > 1 & peak < n), aes(x, y, label = txt, size = max, alpha = -log10(p.adj)), color = "gray10", hjust = 0.5, vjust = 0.5) +
   geom_text(data = subset(lbl, peak == n), aes(x, y, label = txt, size = max, alpha = -log10(p.adj)), color = "gray10", hjust = 1, vjust = 0.5) +
   guides(size = F)

# disable label cropping
gg_table <- ggplot_gtable(ggplot_build(g))
gg_table$layout$clip[gg_table$layout$name=="panel"] <- "off"

grid.draw(gg_table)

dev.off()

require(ape); require(reshape2); require(ggplot2); require(MASS); require(plotrix); require(RColorBrewer); require(scales)

## Read in arguments

args<-commandArgs(TRUE)

file_in           = args[1]              # Input filename
id_col1_index     = as.integer(args[2])  # Index of first id column
id_col2_index     = as.integer(args[3])  # Index of second id column
measure_col_index = as.integer(args[4])  # Index of overlap measure column
measure_type      = as.integer(args[5])  # Measure normalization to apply
factor_col1_index = as.integer(args[6])  # Index of first column with factor values
factor_col2_index = as.integer(args[7])  # Index of second column with factor values
lbl_col1_index    = as.integer(args[8])  # Index of first column with labels
lbl_col2_index    = as.integer(args[9])  # Index of second column with labels
factor_name       = args[10]             # Coloring factor
cont_factor       = args[11]             # Continuous factor?
file_out_hc       = args[12]             # Dendrogram plot filename
file_out_mds      = args[13]             # MDS plot filename
render_plot       = as.logical(args[14]) # Create plots?
file_out_clust    = args[15]             # HCL clusters filename
file_out_coord    = args[16]             # MDS coords filename

# handle no factor case
color_by_factor <- TRUE
if(factor_col1_index < 1) {
   factor_col1_index = id_col1_index
   factor_col2_index = id_col2_index
   color_by_factor   = FALSE
   cont_factor       = FALSE
}

# handle no label case
if(lbl_col1_index < 1) {
   lbl_col1_index = id_col1_index
   lbl_col2_index = id_col2_index
}

## Read data
df <- read.table(file_in, header = T, sep = "\t", comment ="", quote="")

# convert factor columns depending on if continuous coloring is desired or not

if (cont_factor) {
    df[, factor_col1_index] <- as.numeric(as.character(df[, factor_col1_index]))
    df[, factor_col2_index] <- as.numeric(as.character(df[, factor_col2_index]))
} else {
    df[, factor_col1_index] <- as.factor(df[, factor_col1_index])
    df[, factor_col2_index] <- as.factor(df[, factor_col2_index])
}

# Split tables to protect from column overlap, also rename them
# all this stuff is done as R re-formats column names
# e.g. 1_sample_id to X1_sample_id, ...

df.aux <- data.frame(
    id_col1 = df[, id_col1_index], id_col2 = df[, id_col2_index],
    factor_col1 = df[, factor_col1_index], factor_col2 = df[, factor_col2_index],
    lbl_col1 = df[, lbl_col1_index], lbl_col2 = df[, lbl_col2_index]
    )

df <- data.frame(
    id_col1 = df[, id_col1_index], id_col2 = df[, id_col2_index],
    measure_col = as.numeric(as.character(df[, measure_col_index]))
    )

# normalize overlap measure

if (measure_type == 0) {
    # neg log normalization (relative overlap, etc)
    df$measure_col <- -log10(df$measure_col + 1e-9)
} else if (measure_type == 1) {
    # normalizaiton for correlation coefficients
    df$measure_col <- (1 - df$measure_col) / 2
} else if (measure_type == 2) {
      # normalizaiton for similarity indices
      df$measure_col <- 1 - df$measure_col
} else {
    # no normalization (jensen-shannon divergence, etc)
}

## Auxillary table

# trick as we need both columns to get all the data on a factor
# due to the fact that the output is upper triangle of intersection matrix

aux        <- unique(df.aux[c("id_col2", "factor_col2", "lbl_col2")])
names(aux) <- names(df.aux[c("id_col1", "factor_col1", "lbl_col1")])
aux        <- unique(rbind(aux, df.aux[c("id_col1", "factor_col1", "lbl_col1")]))

## Factor & coloring

if (color_by_factor) {
    if (cont_factor) {
       # switch to numeric values and sort by factor
       aux[, "factor_col1"] <- as.numeric(as.character(aux[, "factor_col1"]))
       aux <- aux[order(aux[, "factor_col1"]), ]
    }

    # design a palette to color by unique factor levels
    if (cont_factor) {
       pal <- colorRampPalette(c("#feb24c", "#31a354", "#2b8cbe"))
       fu <- unique(aux[, "factor_col1"])
       cc <- pal(length(fu))
    } else {
       fu <- levels(aux[, "factor_col1"])
       pal <- rep(brewer.pal(8, "Set2"), length(fu)/8 + 1)
       cc <- pal[1:length(fu)]
    }

    # for nan
    cc[is.na(fu)] <- "grey"
}

## Distance

# Symmetrize matrix & compute distance measure

df.1 <- data.frame(id_col1 = df$id_col1, id_col2 = df$id_col2, measure_col = df$measure_col)
df.2 <- df.1
df.2[c("id_col1", "id_col2")] <- df.2[c("id_col2", "id_col1")]
df.sym <- rbind(df.1, df.2)

# cast back to square matrix
df.m <- as.matrix(dcast(df.sym, id_col1 ~ id_col2, value.var = "measure_col"))
rownames(df.m) <- df.m[,1]
df.m <- df.m[,2:ncol(df.m)]
df.m <- df.m[order(rownames(df.m)), order(colnames(df.m))]

# compute distance
df.m <- apply(df.m, 2, as.numeric) # Don't ask me why
diag(df.m) <- 0 # replace diag NAs with 0
df.d <- as.dist(df.m)

## HCL

hcl <- hclust(df.d)

## Dendrogram

# for matching colors and labels
cc_final <- "black"

if (color_by_factor) {
   ind1 <- match(aux[, "factor_col1"], fu)
   ind2 <- match(hcl$labels, aux[, "id_col1"])
   cc_final <- cc[ind1[ind2]]
}

lbl  <- sapply(aux[match(hcl$labels, aux[, "id_col1"]), "lbl_col1"], as.character)

phylo <- as.phylo(hcl)

# save clusters
write.tree(phy=phylo, file="file_out_clust")

# set lables
phylo$tip.label <- lbl

# plotting functions, mostly layout optimization

my.plot <- function(hcl, ...) {
   if (color_by_factor) {
      if (hcl) {
         fig <- c(0.05, 0.75, 0, 1.0)
         mar <- c(0, 0, 0, 0)
      } else {
         fig <- c(0.05, 0.9, 0.1, 0.9)
         mar <- c(2, 4, 2, 4)
      }
   } else {
      if (hcl) {
         fig <- c(0.05, 0.95, 0, 1.0)
         mar <- c(0, 0, 0, 0)
      } else {
         fig <- c(0, 1.0, 0, 1.0)
         mar <- c(4, 4, 4, 4)
      }
   }

   layout(matrix(1:2, ncol=2), width = c(2, 0.1), height = c(1, 1))

   par(fig = fig, mar = mar, xpd = NA) # this ensures labels are not cut

   plot(...)
}

my.legend <- function(hcl) {
   if (color_by_factor) {
      if (hcl) {
         f <- 2
         fig <- c(0.85, 0.95, 0, 1.0)
      } else {
         f <- 1.2
         fig <- c(0.8, 0.95, 0, 1.0)
      }
      par(fig = fig, mar = c(0, 0, 0, 0), xpd = NA, new=TRUE)
      if (cont_factor) {
         # order & get rid of NAs
         fu1 <- fu[ind1]
         cc1 <- cc[ind1]
         cc1 <- cc1[!is.na(fu1)]
         fu1 <- fu1[!is.na(fu1)]

         ux <- grconvertX(c(0.4 - 0.05 * f, 0.4 + 0.05 * f), from = "npc", to = "user")
         uy <- grconvertY(c(0.5 - 0.15, 0.5 + 0.15), from = "npc", to = "user")

         color.legend( ux[1], uy[1], ux[2], uy[2],#-0.39, -0.4,  + 0.39, 0.4,#0.07 + f, 0.1,
                      legend = fu1[c(1, length(fu1)/2 + 1, length(fu1))],
                      rect.col = cc1, gradient = "y", align="rb")

         uy <- grconvertY(0.5 + 0.15 + 0.02, from = "npc", to = "user")
         text(0.5, uy, factor_name, adj = c(0.5, 0.0))
      } else {
         # vanilla legend for discrete factor
         legend("center", "(x,y)", fill = cc, pch = '', box.lwd = 0, title = factor_name, legend = fu)
      }
   }
}

# Plotting device

custom.dev <- function(fname) {
   if (grepl("\\.pdf$",fname)){
      pdf(fname, useDingbats=FALSE)
   } else if (grepl("\\.png$",fname)) {
      png(fname, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
   } else {
      stop('Unknown plotting format')
   }
}

# plot

if (render_plot) {
   custom.dev(file_out_hc)

   my.plot(TRUE, phylo, tip.color = cc_final)
   my.legend(TRUE)

   dev.off()
}

## MDS

mds <- isoMDS(df.d, k = 2)

# move outliers to plot boundaries

apply.bounds <- function(x, y, lp, hp) {
   qx <- quantile(x, c(lp, hp))
   qy <- quantile(y, c(lp, hp))

   oxl <- x <= qx[1]; oxh <- x >= qx[2]
   oyl <- y <= qy[1]; oyh <- y >= qy[2]

   xx <- x
   xx[oxl] = qx[1]; xx[oxh] = qx[2]
   yy <- y
   yy[oyl] = qy[1]; yy[oyh] = qy[2]

   o <- (oxl | oxh | oyl | oyh)

   list(x = xx, y = yy, o = o)
}

x <- mds$points[,1]
y <- mds$points[,2]

xy <- apply.bounds(x, y, 0.1, 0.9)

# re-match label and color

if (color_by_factor) {
   ind3 <- match(row.names(mds$points), aux[, "id_col1"])
   cc_final <-  cc[ind1[ind3]]
}

lbl  <- sapply(aux[match(row.names(as.matrix(df.d)), aux[, "id_col1"]), "lbl_col1"], as.character)
fac  <- sapply(aux[match(row.names(as.matrix(df.d)), aux[, "id_col1"]), "factor_col1"], as.character)

# plot

if (render_plot) {
   custom.dev(file_out_mds)

   my.plot(FALSE, xy$x, xy$y, xlab="mds1", ylab="mds2", type = "n")
   #points(xy$x, xy$y, col = alpha(cc_final, 0.5), pch = 19)
   text(xy$x, xy$y, labels = lbl, col = cc_final, cex=.5)
   #text(xy$x, xy$y, labels = lbl, cex=.5)
   my.legend(FALSE)

   dev.off()
}

# table with mds coordinates
# it will be later used in permutation testing

write.table(data.frame(id = aux[, "id_col1"], lbl = lbl, factor = fac, x=xy$x, y=xy$y),
   file_out_coord, sep = "\t", quote = FALSE, row.names = FALSE)

#
# Prints a stacked area plot for two samples
#

args<-commandArgs(TRUE)

require(ggplot2); require(RColorBrewer)

# data input

sample1_id <- args[1]
sample2_id <- args[2]
file_xy    <- args[3] # should contain cdr3nt, cdr3aa cols; two last columns should correspond to clonotype freq in sample pair
file_out   <- args[4]

# transform data

getcol_n = function(lst, col){
	apply(lst[col], 2, as.numeric)
}

getcol_c = function(lst, col){
	apply(lst[col], 2, as.character)
}

table <- read.delim(file_xy, sep="\t", quote="")
n <- nrow(table)
m <- ncol(table)
table <- table[n:1, ] # reorder, bring non-overlapping / not-shown to the top

x1 <- getcol_n(table, m - 1)
x2 <- getcol_n(table, m)

# here we do change sample labels and further refer to them as s1 and s2
# otherwise R will re-order samples alphabetically by name ...

df <- data.frame(cdr3nt = rep(getcol_c(table, "cdr3nt"), 2),
                 cdr3aa = rep(getcol_c(table, "cdr3aa"), 2),
                 v = rep(getcol_c(table, "v"), 2),
                 d = rep(getcol_c(table, "d"), 2),
                 j = rep(getcol_c(table, "j"), 2),
                 sample = rep(c("s1", "s2"), each = n),
                 expr   = c(x1, x2),
                 peak   = rep(getcol_n(table, "peak"), 2))
                 
df$sign <- paste(df$cdr3nt, df$v, df$d, df$j, sep="_")

# trick to add clonotype labels with geom_text, as suggested at StackExchange

df.0 <- subset(df, sample == "s1")
df.1 <- subset(df, sample == "s2")

#dd <- dd[with(dd, order(cdr3nt, levels(dd$cdr3aa))), ]
df.0$cum <- cumsum(df.0$expr)
df.0$cum <- (c(0, df.0$cum[0:(n-1)]) + df.0$cum) / 2
df.1$cum <- cumsum(df.1$expr)
df.1$cum <- (c(0, df.1$cum[0:(n-1)]) + df.1$cum) / 2

# custom palette (color blind)

gs.pal <- colorRampPalette(c("#2b8cbe", "#e0f3db", "#fdbb84"))

# plotting
emax <- max(df$expr)

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}

ggplot() +
    geom_area(data = df, aes(x = sample, y = expr, fill = cdr3nt,
    group = sign), colour = "grey25", size = 0, position="stack") +
    ylab("cumulative abundance") +
    xlab("") +
    scale_x_discrete(expand = c(0, 0), labels=c(sample1_id, sample2_id)) +
    scale_y_continuous(expand = c(0, 0)) +
    scale_fill_manual(values = c("grey50", "grey25", gs.pal(n - 2))) +
    theme_bw() +
    theme(legend.position = "none") + #, axis.text.x  = element_text(angle=90, vjust=0.5)) +
    geom_text(data = subset(df.0, peak == 0), aes(x = "s1", y = cum, label = cdr3aa, size = expr, alpha = rank(expr)), hjust = 0, vjust = 1) +
    geom_text(data = subset(df.1, peak == 1), aes(x = "s2", y = cum, label = cdr3aa, size = expr, alpha = rank(expr)), hjust = 1, vjust = 1) +
    scale_size_continuous(guide = "none", range = c(3, 10))

dev.off()

#
# Prints a stacked histogram
#

args<-commandArgs(TRUE)

require(ggplot2); require(reshape); require(RColorBrewer)

# data input

file_in    <- args[1]
file_out   <- args[2]
label      <- args[3]
gradient   <- args[4]

# transform data

df <- read.table(file_in, sep ="\t", header = TRUE, comment="", quote="")

# Don't ask me why
df[, 1:ncol(df)] <- apply(df[, 1:ncol(df)], 2, as.numeric)

df.m <- melt(df, id = "Len")

# trick to add clonotype labels with geom_text, as suggested at StackExchange

#dd <- subset(df, sample == "s2")

#dd <- dd[with(dd, order(cdr3nt, levels(dd$cdr3aa))), ]
#dd$cum <- cumsum(dd$expr)

# custom palette (color blind)

if (gradient) {
   pal <- colorRampPalette(c("#2b8cbe", "#e0f3db", "#fdbb84"))(ncol(df) - 2)
} else {
   pal <- brewer.pal(ncol(df) - 2, "Paired")
}

# plotting

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 4.25,
                  height    = 2.25,
                  units     = "in",
                  res       = 1200,
                  pointsize = 4)
} else {
   stop('Unknown plotting format')
}

ggplot(df.m, aes(x = Len, y = value, fill = variable)) +
  geom_bar(width = 1, stat = "identity") +
  xlab("CDR3 length, bp") +
  labs(fill=label) +
  scale_x_continuous(expand = c(0, 0)) +
  scale_y_continuous(expand = c(0, 0)) +
  scale_fill_manual(values=c("grey75", pal)) +
  theme_bw() +
  theme(legend.text=element_text(size=8), axis.title.y=element_blank()) +
  guides(fill = guide_legend(reverse = TRUE))

dev.off()

require(gplots); require(RColorBrewer); require(ggplot2); require(plotrix)

args<-commandArgs(TRUE)

input_file  <- args[1] #"ms.segments.V2.txt"
v_col_count <- as.numeric(args[2])
lbl_col     <- as.numeric(args[3])
fac_col     <- as.numeric(args[4])
cont_factor <- as.logical(args[5]) # continuous factor?
file_out <- args[6]

if (lbl_col < 1) {
   lbl_col = 1 # use sample id if not specified
}

color_by_factor <- fac_col > 0 # any color legend for samples?

# read-in data and pre-process
df<-read.table(input_file, header=T, sep="\t", comment="")
vcols<-(ncol(df)-v_col_count + 1):ncol(df)
df[, vcols] <- apply(df[, vcols], 2, as.numeric)
x <- as.matrix(df[, vcols])

# prepare palletes and factor levels
if (color_by_factor) {
    factor_name <- colnames(df)[fac_col]
    if (cont_factor) {
       df[, fac_col] <- as.numeric(df[,fac_col])
       # base pallete, to be used in legend
       scol <- colorRampPalette(c("#feb24c", "#31a354", "#2b8cbe"))(10)
       # color vector for plot
       pcol <- scol[cut(df[,fac_col], 10)]
    } else {
       df[, fac_col] <- as.factor(df[, fac_col])
       fu   <- levels(df[, fac_col])
       nlevels <- length(fu)
       # base pallete, to be used in legend
       scol <- colorRampPalette(brewer.pal(nlevels, "Set2"))(nlevels)
       # color vector for plot
       pcol <- scol[df[,fac_col]]
    }
}

# plotting function for simplicity
my.plot <- function(...) {
   heatmap.2(t(x),  na.rm=F, labCol = df[,lbl_col],
      na.col="grey50",
      col=colorRampPalette(c("#2f98ce", "#e0f3db", "#f47104")),
      density.info="none", trace="none",scale="column",
      ...)
}

custom.dev <- function(fname) {
   if (grepl("\\.pdf$",fname)){
      pdf(fname)
   } else if (grepl("\\.png$",fname)) {
      png(fname, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
   } else {
      stop('Unknown plotting format')
   }
}

if (color_by_factor) {
   custom.dev(file_out)

   # layout plot
   fig <- c(0.05, 0.75, 0, 1.0)
   mar <- c(0, 0, 0, 0)

   layout(matrix(1:2, ncol=2), width = c(2, 0.1), height = c(1, 1))

   par(fig = fig, mar = mar, xpd = NA) # this ensures labels are not cut

   # plot with coloring columns
   my.plot(ColSideColors=pcol)

   # draw a separate legend
   fig <- c(0.85, 1.00, 0, 1.0)

   par(fig = fig, mar = c(0, 0, 0, 0), xpd = NA, new=TRUE)

   if (cont_factor) {
      # set colorbar pos
      f <- 2
      ux <- grconvertX(c(0.48 - 0.05 * f, 0.48 + 0.05 * f), from = "npc", to = "user")
      uy <- grconvertY(c(0.87 - 0.07, 0.87 + 0.07), from = "npc", to = "user")

      # gradient legend
      fmin <- min(df[, fac_col])
      fmax <- max(df[, fac_col])
      color.legend(ux[1], uy[1], ux[2], uy[2],
                   legend = c(fmin, (fmin+fmax) / 2, fmax),
                   rect.col = scol, gradient = "y", align="rb")

      # position title
      uy <- grconvertY(0.96, from = "npc", to = "user")
      text(0.5, uy, factor_name, adj = c(0.5, 0.0))
   } else {
      # vanilla legend for discrete factor
      legend("top", "(x,y)", fill = scol, pch = '', box.lwd = 0, title = factor_name, legend = fu)
   }

   dev.off()
} else {
   custom.dev(file_out)

   # layout plot
   fig <- c(0.05, 0.95, 0, 1.0)
   mar <- c(0, 0, 0, 0)

   layout(matrix(1:2, ncol=2), width = c(2, 0.1), height = c(1, 1))

   par(fig = fig, mar = mar, xpd = NA) # this ensures labels are not cut

   my.plot()

   dev.off()
}

#
# Prints a scatterplot with marginal distributions
# Note that while scatterplot is based only on vector of species present in sample intersection,
# marginal plots are built based on complete datasets
#
# Adapted from R-bloggers (http://www.r-bloggers.com/ggplot2-cheatsheet-for-visualizing-distributions/)
# With minor additions based on various StackOverflow replies
#

#options(error=traceback)

require(ggplot2); require(grid); require(gridExtra); require(reshape); require(grid)

# data input

args<-commandArgs(TRUE)

sample1_id <- args[1]
sample2_id <- args[2]
file_xy    <- args[3]
file_xx    <- args[4]
file_yy    <- args[5]
file_out   <- args[6]

# transform data
to_double = function(x) {
  log10(as.numeric(as.character(x))+1e-7)
}

xy <- read.table(file_xy, header=T)
xy$x <- to_double(xy$x)
xy$y <- to_double(xy$y)

xx <- read.table(file_xx, header=T)
xx$xx <- to_double(xx$xx)
#xx <- rbind(subset(melt(xy),variable=="x"), melt(xx))

yy <- read.table(file_yy, header=T)
yy$yy <- to_double(yy$yy)
#yy <- rbind(subset(melt(xy),variable=="y"), melt(yy))

xmin <- min(xx$xx, yy$yy)

# For regression info plotting. source: http://goo.gl/K4yh
lm_eqn = function(df){
  m = lm(y ~ x, df);
  eq <- substitute(italic(y) == a + b %.% italic(x)*","~~italic(r)^2~"="~r2, 
                   list(a = format(coef(m)[1], digits = 2), 
                        b = format(coef(m)[2], digits = 2), 
                        r2 = format(summary(m)$r.squared, digits = 3)))
  as.character(as.expression(eq))               
}

# plotting
 
if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}

# placeholder (top right)

empty <- ggplot() +
     geom_point(aes(1,1), colour="white") +
     theme(                              
       plot.background  = element_blank(), 
       panel.grid.major = element_blank(), 
       panel.grid.minor = element_blank(), 
       panel.border     = element_blank(), 
       panel.background = element_blank(),
       axis.title.x     = element_blank(),
       axis.title.y     = element_blank(),
       axis.text.x      = element_blank(),
       axis.text.y      = element_blank(),
       axis.ticks       = element_blank(),
       plot.margin      = unit(c(3, -5.5, 4, 3), "mm")
     )

# scatterplot

scatter <- ggplot() + 
  theme_bw() +
  geom_point(data = xy, aes(x, y, size = (x + y) / 2),
     fill   = "red", 
     colour = "black",
     alpha  = 0.4,
     pch    = 21
     ) +
  geom_text(data = data.frame(), aes(x = xmin, y = 0, label = lm_eqn(xy)), hjust = 0, parse = TRUE) +
  stat_smooth(data = xy, aes(x, y, weight = 10^((x + y) / 2)), color= "gray25", method = "lm", fullrange = T) +
  scale_x_continuous(limit = c(xmin, 0), expand = c(0, 0.1)) +
  scale_y_continuous(limit = c(xmin, 0), expand = c(0, 0.1)) +
  scale_size_continuous(guide = "none", range = c(1, 10)) +
  xlab(sample1_id) +
  ylab(sample2_id) +  
  theme(legend.position = c(1, 1), legend.justification = c(1, 1))

# marginal density of x

plot_top <- ggplot() +  
  stat_density(data=xx, aes(x=xx, weight=10^xx/sum(10^xx), y = ..scaled..),
               fill = "grey50", colour = "gray25", size = 0.1, alpha = 0.4, adjust = 1) +
  stat_density(data=xy, aes(x=x, weight=10^x/sum(10^x), y = ..scaled..), 
               fill = "red", colour = "gray25", size = 0.1, alpha = 0.4, adjust = 1) +
  scale_x_continuous(limit = c(xmin, 0), expand = c(0, 0.25)) +
  ylab("") + theme_bw() +
  theme(legend.position = "none", axis.title.x = element_blank(), 
        axis.text = element_blank(), axis.ticks = element_blank(), 
        panel.grid  = element_blank())


# marginal density of y

plot_right <- ggplot() +  
  stat_density(data=yy, aes(x=yy, weight=10^yy/sum(10^yy), y = ..scaled..),
               fill = "grey50", colour = "gray25", size = 0.1, alpha = 0.4, adjust = 1) +
  stat_density(data=xy, aes(x=y, weight=10^y/sum(10^y), y = ..scaled..), 
               fill = "red", colour = "gray25", size = 0.1, alpha = 0.4, adjust = 1) +
  scale_x_continuous(limit = c(xmin, 0), expand = c(0, 0.2)) +
  coord_flip() + 
  ylab("") + theme_bw() +
  theme(legend.position = "none", axis.title.y = element_blank(), 
        axis.text = element_blank(), axis.ticks = element_blank(),
        panel.grid  = element_blank()) 

# arrange the plots together, with appropriate height and width for each row and column

grid.arrange(plot_top, empty, scatter, plot_right, ncol = 2, nrow = 2, widths = c(4, 1), heights = c(1, 4))

dev.off()

# This simple script tests R dependency installation for VDJtools
args    <- commandArgs(TRUE)

# iterate over dependencies
passed <- T
for (i in 1:length(args)) {
   if (!args[i] %in% rownames(installed.packages())) {
       print(paste("FAILED to install ", args[i]))
       passed <- F
   }
}

if (passed) {
   print("PASSED")
}

# This simple script automates R dependency installation for VDJtools
args    <- commandArgs(TRUE)
libPath <- args[1]

# iterate over dependencies
for (i in 2:length(args)) {
   # install packages to local library, use 0-Cloud mirror
   # note that local library is set as default search path path by RUtil
   install.packages(args[i], lib=libPath, repos="http://cran.rstudio.com/")
}

args<-commandArgs(TRUE)

label    <- args[1]
input    <- args[2]
file_out <- args[3]

require(ggplot2); require(reshape)

# preprocess data

tbl <- read.delim(input, sep = "\t")
tbl <- apply(tbl, 1:2, as.numeric)

df <- data.frame(tbl)
df <- melt(df, id = 'time', variable_name = 'series')

# plot series as facets

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 4.25,
                 height    = 2.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}

ggplot(df, aes(time, value)) +
    geom_point(aes(colour = series)) +
    geom_step(aes(colour = series)) +
    scale_x_continuous(limit = c(min(df$time), max(df$time)),
                        breaks = df$time) +
    scale_y_continuous(limit = c(0, 1)) +
    facet_grid(series ~ .) +
    xlab(label) +
    ylab("") +
    guides(colour=FALSE)

dev.off()

#
# Prints a stacked area plot for two samples
#

args<-commandArgs(TRUE)

require(ggplot2); require(reshape); require(RColorBrewer); require(FField)

# data input

sample1_id <- args[1]
sample2_id <- args[2]
file_in  <- args[3]
file_out <- args[4]

# transform data

table <- read.table(file_in, header=T, comment="", sep="\t", quote="", stringsAsFactors=F)
n <- nrow(table)
m <- ncol(table)
table <- table[n:1, ] # reorder, bring non-overlapping / not-shown to the top

sample_ids <- c(sample1_id, sample2_id)

# here we do change sample labels and further refer to them as 0 and 1
# otherwise R will re-order samples alphabetically by name ...

df <- data.frame(cdr3nt = rep(table$cdr3nt, 2),
                 cdr3aa = rep(table$cdr3aa, 2),
                 v = rep(table$v, 2),
                 d = rep(table$d, 2),
                 j = rep(table$j, 2),
                 sample = rep(c(0, 1), each = n),
                 expr   = as.numeric(c(table[,m-1], table[,m])),
                 peak   = rep(as.integer(table$peak), 2))
                 
df$sign <- paste(df$cdr3nt, df$v, df$d, df$j, sep="_")

# trick to add clonotype labels with geom_text, as suggested at StackExchange

df.0 <- subset(df, sample == 0)
df.1 <- subset(df, sample == 1)

#dd <- dd[with(dd, order(cdr3nt, levels(dd$cdr3aa))), ]
df.0$cum <- cumsum(df.0$expr)
df.0$cum <- (c(0, df.0$cum[0:(n-1)]) + df.0$cum) / 2
df.1$cum <- cumsum(df.1$expr)
df.1$cum <- (c(0, df.1$cum[0:(n-1)]) + df.1$cum) / 2

# for label placement
jitter_coord = function(y) {
    if (length(y) >= 2) {
       y.fact <- 100 / max(y)
       coords <- FFieldPtRep(coords = cbind(y * y.fact, y * y.fact), iter.max = 1000)
       y <- coords$y / y.fact
       y <- (y - min(y)) / (max(y) - min(y))
    } else {
       y
    }
}

# placing
df.00 <- subset(df.0, peak == 0)
df.00$cum2 <- jitter_coord(df.00$cum)
df.11 <- subset(df.1, peak == 1)
df.11$cum2 <- jitter_coord(df.11$cum)

# custom palette (color blind)

gs.pal <- colorRampPalette(c("#2b8cbe", "#e0f3db", "#fdbb84"))

# plotting
emax <- max(df$expr)

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}

ggplot() +
    geom_area(data = df, aes(x = sample, y = expr, fill = cdr3nt,
    group = sign), colour = "grey25", size = 0.01, position="stack") +
    ylab("cumulative abundance") +
    xlab("") +
    scale_x_continuous(expand = c(0, 0), labels=sample_ids, breaks=c(0,1), limits=c(-1,2)) +
    scale_y_continuous(expand = c(0, 0), limits=c(-0.2,1.2), breaks=c(0,0.25,0.5,0.75,1)) +
    scale_fill_manual(values = c("grey50", "grey25", gs.pal(n - 2))) +
    theme_bw() +
    theme(legend.position = "none") +
    geom_text(data = df.00, 
              aes(x = -0.25, y = cum2, label = cdr3aa), hjust = 1, size=3) +
    geom_segment(data = df.00, x=0,xend=-0.23, aes(y=cum, yend=cum2), size=0.3) +
    geom_text(data = df.11, 
              aes(x = 1.25, y = cum2, label = cdr3aa), hjust = 0, size=3) +  
    geom_segment(data = df.11, x=1,xend=1.23, aes(y=cum, yend=cum2), size=0.3) +  
    theme(panel.grid.major = element_blank(), panel.grid.minor = element_blank())

dev.off()

args <- commandArgs(TRUE)

require(ggplot2); require(reshape); require(gridExtra); require(grid)

file_in  <- args[1]
file_out <- args[2]

# preprocess data

df <- read.table(file_in, header=TRUE, comment.char="", sep = "\t")

df$value <- as.numeric(as.character(df$value)) # yet again don't ask me why

get_plot <- function(metric_value) {
   ggplot(subset(df, metric == metric_value), aes(factor(X1_time), factor(X2_time))) +
       geom_tile(aes(fill = value), colour = "white") +
       scale_fill_gradient(low = "white", high = "steelblue") +
       coord_fixed(ratio = 1) +
       facet_wrap( ~ metric) +
       scale_x_discrete(expand = c(0, 0)) +
       scale_y_discrete(expand = c(0, 0)) +
       xlab("") + ylab("") +
       #guides(fill = guide_legend(title = "")) +
       theme(
                legend.title = element_blank(),
                legend.text = element_text(angle = 45, hjust = 0),
                legend.position = "bottom",
                axis.ticks = element_blank(),
                axis.text.x = element_text(angle = 90, hjust = 0)
                )
}

g1 <- get_plot("count")
g2 <- get_plot("diversity")
g3 <- get_plot("frequency")

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}
             
grid.arrange(g1, g2, g3, ncol=3, nrow=1)

dev.off()

require(ggplot2); require(RColorBrewer)

args<-commandArgs(TRUE)

file_in    <- args[1]
file_out   <- args[2]

df <- read.table(file_in, header=T, comment="", sep = "\t")
df$value <- as.numeric(as.character(df$value))

# this routine prepares data for donut plot representation
makesub <- function(t) {
	tmp <- subset(df, type %in% t)
	tmp$vmax = cumsum(tmp$value)
	tmp$vmin = c(0, head(tmp$vmax, n=-1))	
	tmp
}

# select color for different arcs
makecol <- function(d, pal) {
    col <- character(nrow(d))
	p <- colorRampPalette(pal)(nrow(d))
	
	for (i in 1:nrow(d)) {
	   names(col)[i] <- as.character(d$name[i])
	   col[i] <- p[i]
	}
	
	col
}

# format three levels of data
# set - singletons, doubletons & high-order
# quantile - q1..q5
# top - top1 clonotype, top2 clonotype...
df.1 <- makesub("set")
df.2 <- makesub("quantile")
df.3 <- makesub("top")

col <- makecol(df.1, brewer.pal(3,"RdYlBu"))
col <- c(col, makecol(df.2, rev(brewer.pal(3,"Oranges"))))
col <- c(col, makecol(df.3, rev(brewer.pal(3,"OrRd"))))

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 3.25,
                 height    = 3.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}

ggplot() +
     geom_rect(data = df.1, colour="grey30", aes(fill=name, ymax=vmax, ymin=vmin, xmax=2,xmin=1)) +
     geom_rect(data = df.2, colour="grey30", aes(fill=name, ymax=vmax, ymin=vmin, xmax=4,xmin=2)) +
     geom_rect(data = df.3, colour="grey30", aes(fill=name, ymax=vmax, ymin=vmin, xmax=7,xmin=4)) +
     # here we also rotate text to point to right direction
     geom_text(data = df.1, aes(x=1.5, y = value/2 + c(0, cumsum(value)[-length(value)]), angle=180-..y..*360, label = name), size=4)+
     geom_text(data = df.2, aes(x=3.0, y = value/2 + c(0, cumsum(value)[-length(value)]), angle=90-..y..*360, label = name), size=4)+
     geom_text(data = df.3, aes(x=4, y = value/2 + c(0, cumsum(value)[-length(value)]), angle=90-..y..*360, label = name, size = log10(value)), hjust=0.0)+
     coord_polar(theta="y") +
     scale_x_continuous(expand=c(0,0),limits=c(0, 7)) +
     scale_fill_manual(values=col)+
     xlab("") + ylab("")+
     theme_bw() +
     theme(panel.grid=element_blank()) +
     theme(panel.border=element_blank()) +
     theme(axis.text=element_blank()) +
     theme(axis.ticks=element_blank()) + 
     theme(legend.position="none")

dev.off()

args<-commandArgs(TRUE)

require(reshape); require(ggplot2); require(gridExtra); require(FField); require(grid)

file_in   <- args[1] #"rarefaction.strict.txt"
lbl_col   <- as.integer(args[2]) #5
fac_col   <- as.integer(args[3]) #6
num_fac   <- as.logical(args[4]) #"F"
add_lbl   <- as.logical(args[5]) #"T"
wide      <- as.logical(args[6]) #"F"
lab_exact <- as.logical(args[7]) #"F"
file_out  <- args[8] # "rarefaction.strict.pdf"

df <- read.table(file_in,header=T,comment="",sep="\t")

# get name of label and factor
fac_name<-names(df)[fac_col]

# make sure that we parse numeric factor as needed
if (num_fac) {
   df[,fac_col] <- as.numeric(as.character(df[,fac_col]))
}

# rename columns so we can access them
# this is done as some column names could be quite complex to pass by command line,
# e.g. #1_label will be converted to X1.label, etc
# we also protect from column name collisions
df <- data.frame(dataset = df[,1],
                 fac  =  df[,fac_col],
                 lbl  =  df[,lbl_col],
                 type =  df[,ncol(df)],
                 ciU  =  df[,ncol(df)-1],
                 ciL  =  df[,ncol(df)-2],
                 mean =  df[,ncol(df)-3],
                 x    =  df[,ncol(df)-4])

# those are the last points with observed diversity
# we'll highlight them with point and (if required) a label
df.p <- subset(df, type==2 & x==max(df$x))
if (lab_exact) {
   df.l <- subset(df, type==1)
} else {
   df.l <- df.p
}

if (add_lbl) {
   # We absolutely sure need this trick as labels are going to overlap leading to huge mess..
   x.fact <- 100 / max(df.l$x)
   y.fact <- 100 / max(df.l$mean)
   coords <- FFieldPtRep(coords = cbind(df.l$x * x.fact, df.l$mean * y.fact), iter.max = 1000)
   df.l$x <- coords$x / x.fact
   df.l$mean <- coords$y / y.fact
} else {
   df.l <- df.l[0, ]
}

# interpolated & extrapolated
df.i <- subset(df, type==0)
df.o <- subset(df, type==1)
df.e <- subset(df, type==2)

g <- ggplot(df, aes(x=x, y=mean, group=dataset)) +
     geom_point(data=df.o, aes(colour=fac)) +
     geom_line(data=df.i, aes(colour=fac), linetype="solid") +
     geom_line(data=df.e, aes(colour=fac), linetype="dashed") +
     geom_ribbon(aes(ymin=ciL, ymax=ciU), alpha=0.2) +
	 xlab("Sample size") + ylab("Diveristy") +
	 labs(colour=fac_name) +
	 scale_x_continuous(oob=scales::rescale_none) +
	 scale_y_continuous(oob=scales::rescale_none) +
	 theme_bw()

# add corresponding fancy axis
if (num_fac) {
   g <- g + scale_colour_gradient2(low="#feb24c", mid="#31a354", high="#2b8cbe", midpoint=(max(df$fac) + min(df$fac))/2)
} else if (fac_col > 1) {
   g <- g + scale_colour_brewer(palette="Set2")
}

g <- g + geom_text(data=df.l, aes(label=lbl), color="black", fontface = "plain", hjust=1.0, vjust=0.5, cex=2.5)

if (grepl("\\.pdf$",file_out)){
   pdf(file_out)
} else if (grepl("\\.png$",file_out)) {
   png(file_out, width     = 4.25,
                 height    = 2.25,
                 units     = "in",
                 res       = 1200,
                 pointsize = 4)
} else {
   stop('Unknown plotting format')
}

if (wide) {
   # wide plot layout
   grid.arrange(g, ncol=1, nrow=2)
} else {
   g
}

dev.off()

VDJTOOLS="java -Xmx4G -jar ../build/libs/vdjtools-*.jar"
cd aging_lite/

# basic analysis
$VDJTOOLS CalcBasicStats -m metadata.txt out/0
$VDJTOOLS CalcSpectratype -m metadata.txt out/1
$VDJTOOLS CalcSegmentUsage -m metadata.txt -p -f age -n out/2
$VDJTOOLS PlotFancySpectratype A4-i125.txt.gz out/3
$VDJTOOLS PlotSpectratypeV A4-i125.txt.gz out/4
$VDJTOOLS PlotFancyVJUsage A4-i125.txt.gz out/5

# diversity estimates
$VDJTOOLS PlotQuantileStats A4-i125.txt.gz out/6
$VDJTOOLS CalcDiversityStats -m metadata.txt out/7
$VDJTOOLS RarefactionPlot -m metadata.txt -f age -n -l sample.id out/8

# sample overlap
$VDJTOOLS OverlapPair -p A4-i189.txt.gz A4-i190.txt.gz out/9
$VDJTOOLS CalcPairwiseDistances -m metadata.small.txt out/10
$VDJTOOLS ClusterSamples -p -f age -n -l sample.id out/10 out/10.age

# sample operations and filtering
$VDJTOOLS Decontaminate -m metadata.txt -c out/dec/
$VDJTOOLS Downsample -m metadata.txt -c -x 10000 out/ds/
$VDJTOOLS FilterNonFunctional -m metadata.txt -c out/nf/
$VDJTOOLS JoinSamples -p -m metadata.small.txt out/12
$VDJTOOLS PoolSamples -m metadata.small.txt out/13

# annotation
$VDJTOOLS CalcCdrAaStats -m metadata.txt out/14
$VDJTOOLS Annotate -m metadata.txt out/annot/
$VDJTOOLS SegmentsToFamilies -s human -m metadata.txt out/s2f/
$VDJTOOLS CalcDegreeStats -m metadata.txt out/degstat/

# check all output files are generated

cd out/
ls -lh

flist=(
        '0.basicstats.txt'
        '1.spectratype.insert.wt.txt'
        '1.spectratype.ndn.wt.txt'
        '1.spectratype.nt.wt.txt'
        '2.segments.wt.J.pdf'
        '2.segments.wt.J.txt'
        '2.segments.wt.V.pdf'
        '2.segments.wt.V.txt'
        '3.fancyspectra.pdf'
        '3.fancyspectra.txt'
        '4.spectraV.wt.pdf'
        '4.spectraV.wt.txt'
        '5.fancyvj.wt.pdf'
        '5.fancyvj.wt.txt'
        '6.qstat.pdf'
        '6.qstat.txt'
        '7.diversity.strict.exact.txt'
        '7.diversity.strict.resampled.txt'
        '8.rarefaction.strict.pdf'
        '8.rarefaction.strict.txt'
        '9.paired.strict.summary.txt'
        '9.paired.strict.table.collapsed.pdf'
        '9.paired.strict.table.collapsed.txt'
        '9.paired.strict.table.txt'
        '9.strict.paired.scatter.pdf'
        '10.age.hc.aa.F.pdf'
        '10.age.mds.aa.F.pdf'
        '10.age.mds.aa.F.txt'
        '10.intersect.batch.aa.txt'
        '12.join.aa.summary.txt'
        '12.join.aa.table.txt'
        '12.join.aa.venn.pdf'
        '13.pool.aa.table.txt'
        '14.cdr3aa.stat.unwt.unnorm.txt'
        'dec/metadata.txt'
        'ds/metadata.txt'
        'nf/metadata.txt'
        'annot/metadata.txt'
        's2f/metadata.txt'
        'degstat/metadata.txt'
    )

for f in "${flist[@]}"
do
    if [[ ! -s $f ]]
        then exit 1
    fi
done
